&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*------------------------------------------------------------------------
    File        : rtb_dbinckrpt.p
    Description : Database integrity check report
    Created     : Dec 2002
    Notes       : Requires DICTDB alias to be created for database prior
                  to calling this procedure.
  ----------------------------------------------------------------------*/
/*          This .P file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */
DEFINE INPUT PARAMETER PobjRowid AS ROWID       NO-UNDO.
DEFINE INPUT PARAMETER Pfilename AS CHARACTER   NO-UNDO.
DEFINE INPUT PARAMETER PdiffOnly  AS LOGICAL     NO-UNDO.

/* Local Variable Definitions ---                                       */
DEFINE VARIABLE MdbValue   AS CHARACTER   NO-UNDO.
DEFINE VARIABLE Merror     AS CHARACTER   NO-UNDO.
DEFINE VARIABLE MrtbValue  AS CHARACTER   NO-UNDO.
DEFINE VARIABLE MerrCount  AS INTEGER     NO-UNDO.
DEFINE VARIABLE MprintName AS LOGICAL     NO-UNDO.

DEFINE BUFFER B_db        FOR DICTDB._Db.
DEFINE BUFFER Brtb_dbase  FOR rtb.rtb_dbase.
DEFINE BUFFER Brtb_object FOR rtb.rtb_object.

DEFINE STREAM Sout.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&IF DEFINED(EXCLUDE-fnIsSameString) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD fnIsSameString Procedure 
FUNCTION fnIsSameString RETURNS LOGICAL PRIVATE
        ( INPUT pcValue1 AS CHARACTER,
          INPUT pcValue2 AS CHARACTER ) FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 15
         WIDTH              = 60.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */
{rtb/i/rtb_s_dbase.i}
{rtb/i/rtb_scharea.i}


OUTPUT STREAM Sout TO VALUE(Pfilename) PAGED.

RUN do_report.

IF RETURN-VALUE <> "" THEN 
  PUT STREAM Sout UNFORMATTED "ERROR :" RETURN-VALUE.

OUTPUT STREAM Sout CLOSE.

/*
 Return the return value of the above procedure
*/
RETURN RETURN-VALUE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-check_fields) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE check_fields Procedure 
PROCEDURE check_fields PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Check each field in specified file
  Parameters:  BUFFER B_file       - _File buffer
               BUFFER Brtb_file    - rtb_file buffer
               BUFFER Brtb_dbfile  - rtb_dbfile buffer
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE PARAMETER BUFFER B_File      FOR DICTDB._File.
  DEFINE PARAMETER BUFFER Brtb_file   FOR rtb.rtb_file.
  DEFINE PARAMETER BUFFER Brtb_dbfile FOR rtb.rtb_dbfile.

  DEFINE VARIABLE Mflddef-pmod       AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mflddef-upd-status AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mflddef-version    AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mvalues            AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Ms                 AS INTEGER     NO-UNDO.
  DEFINE VARIABLE MhFldBuff          AS HANDLE      NO-UNDO.

  DEFINE BUFFER B_field     FOR DICTDB._Field.
  DEFINE BUFFER Brtb_field  FOR rtb.rtb_field.
  DEFINE BUFFER Brtb_flddef FOR rtb.rtb_flddef.

  rtb-field-loop:
  FOR EACH Brtb_field OF Brtb_file NO-LOCK:

    FIND B_field OF B_file
       WHERE B_field._field-name = Brtb_field.local-field-name
       NO-LOCK NO-ERROR.

    IF NOT AVAILABLE B_field THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("Field",
                                "",
                                Brtb_field.local-field-name,
                                "rtb-only":U).
      NEXT rtb-field-loop.
    END.

    MhFldBuff = BUFFER B_field:HANDLE.

    /*
     Get version and pmod of field
    */
    Mvalues = DYNAMIC-FUNCTION('fnRtbGetSchemaPmodVer':U,
                               Brtb_object.wspace-id,
                               -2,
                               Brtb_field.flddef-obj-type,
                               Brtb_field.flddef-object).
    IF ENTRY(1,Mvalues,CHR(1)) = "ERROR":U THEN DO:
      Merror = ENTRY(1,Mvalues,CHR(1)).
    END.
    ELSE
      ASSIGN Mflddef-pmod = ENTRY(1,Mvalues,CHR(1))
             Mflddef-version = INTEGER(ENTRY(2,Mvalues,CHR(1)))
             Mflddef-upd-status = ENTRY(3,Mvalues,CHR(1)).

    FIND Brtb_flddef 
       WHERE Brtb_flddef.pmod     = Mflddef-pmod
         AND Brtb_flddef.obj-type = Brtb_field.flddef-obj-type
         AND Brtb_flddef.object   = Brtb_field.flddef-object
         AND Brtb_flddef.version  = Mflddef-version
         NO-LOCK.

    IF Brtb_field.rtb_order <> B_field._order
       OR Brtb_field.rtb_mandatory <> B_field._mandatory
       OR NOT fnIsSameString(Brtb_field.local-field-name,B_field._field-name)
       OR Brtb_flddef.rtb_data-type <> B_field._data-type
       OR NOT fnIsSameString(Brtb_flddef.rtb_initial,B_field._initial)
       OR NOT fnIsSameString(Brtb_flddef.rtb_label,B_field._label)
       OR NOT fnIsSameString(Brtb_flddef.rtb_format,B_field._format)
       OR Brtb_flddef.rtb_decimals <> B_field._decimals
       OR Brtb_flddef.rtb_extent <> B_field._extent
       OR NOT fnIsSameString(Brtb_flddef.rtb_valexp,B_field._valexp)
       OR NOT fnIsSameString(Brtb_flddef.rtb_valmsg,B_field._valmsg)
       OR NOT fnIsSameString(Brtb_flddef.rtb_help,B_field._help)
       OR NOT fnIsSameString(Brtb_flddef.rtb_desc,B_field._desc)
       OR NOT fnIsSameString(Brtb_flddef.rtb_col-label,B_field._col-label)
       OR Brtb_flddef.rtb_fld-case <> B_field._fld-case
       OR NOT fnIsSameString(Brtb_flddef.rtb_view-as,B_field._view-as)
       OR NOT fnIsSameString(Brtb_flddef.rtb_col-label-sa,B_field._col-label-sa)
       OR NOT fnIsSameString(Brtb_flddef.rtb_format-sa,B_field._format-sa)
       OR NOT fnIsSameString(Brtb_flddef.rtb_help-sa,B_field._help-sa)
       OR NOT fnIsSameString(Brtb_flddef.rtb_initial-sa,B_field._initial-sa)
       OR NOT fnIsSameString(Brtb_flddef.rtb_label-sa,B_field._label-sa)
       OR NOT fnIsSameString(Brtb_flddef.rtb_valmsg-sa,B_field._valmsg-sa)
       OR Brtb_flddef.rtb_Width        <> B_field._width
       OR (B_Field._Data-Type MATCHES ".LOB"
           AND Brtb_field.area-name <> getStorageAreaName({&LOB-OBJECT}, B_field._Fld-stlen))
       OR (INTEGER(DBVERSION("DICTDB":U)) > 9
           AND B_field._Data-type = "CLOB":U
           AND
           (Brtb_field.rtb_Attributes1  <> MhFldBuff:BUFFER-FIELD("_Attributes1":U):BUFFER-VALUE
            OR Brtb_field.rtb_Charset   <> MhFldBuff:BUFFER-FIELD("_Charset":U):BUFFER-VALUE
            OR Brtb_field.rtb_Collation <> MhFldBuff:BUFFER-FIELD("_Collation":U):BUFFER-VALUE)
            OR Brtb_flddef.rtb_Fld-misc2[1] <> MhFldBuff:BUFFER-FIELD("_Fld-misc2":U):BUFFER-VALUE(1))
       THEN DO:

      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).

      PUT STREAM Sout UNFORMATTED
        "**Difference(s) in Field " B_field._field-name " :" SKIP.

      IF Brtb_field.rtb_order <> B_field._order THEN 
        RUN rtb_show_discrepancy ("_order",
                                  STRING(B_field._order),
                                  STRING(Brtb_field.rtb_order),
                                  "dbrtb").

      IF Brtb_field.rtb_mandatory <> B_field._mandatory THEN
        RUN rtb_show_discrepancy ("_mandatory",
                                  STRING(B_field._mandatory),
                                  STRING(Brtb_field.rtb_mandatory),
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_field.local-field-name,B_field._field-name) THEN
        RUN rtb_show_discrepancy ("_field-name",
                                  STRING(B_field._field-name),
                                  STRING(Brtb_field.local-field-name),
                                  "dbrtb").

      IF B_Field._Data-Type MATCHES ".LOB"
         AND Brtb_field.area-name <> getStorageAreaName({&LOB-OBJECT}, B_field._Fld-stlen) THEN
        RUN rtb_show_discrepancy ("Storage Area",
                                  getStorageAreaName({&LOB-OBJECT}, B_field._Fld-stlen),
                                  Brtb_field.area-name,
                                  "dbrtb").
      
      IF Brtb_flddef.rtb_data-type   <> B_field._data-type THEN
        RUN rtb_show_discrepancy ("_data-type",
                                  STRING(B_field._data-type),
                                  STRING(Brtb_flddef.rtb_data-type),
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_initial,B_field._initial) THEN
        RUN rtb_show_discrepancy ("_initial",
                                  B_field._initial,
                                  Brtb_flddef.rtb_initial,
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_label,B_field._label) THEN
        RUN rtb_show_discrepancy ("_label",
                                  B_field._label,
                                  Brtb_flddef.rtb_label,
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_format,B_field._format) THEN
        RUN rtb_show_discrepancy ("_format",
                                  B_field._format,
                                  Brtb_flddef.rtb_format,
                                  "dbrtb").

      IF Brtb_flddef.rtb_decimals <> B_field._decimals THEN
        RUN rtb_show_discrepancy ("_decimals",
                                  STRING(B_field._decimals),
                                  STRING(Brtb_flddef.rtb_decimals),
                                  "dbrtb").

      IF Brtb_flddef.rtb_extent <> B_field._extent THEN
        RUN rtb_show_discrepancy ("_extent",
                                  STRING(B_field._extent),
                                  STRING(Brtb_flddef.rtb_extent),
                                  "dbrtb").

      IF INTEGER(DBVERSION("DICTDB":U)) > 9 AND B_field._Data-type = "CLOB":U THEN DO:
        IF Brtb_field.rtb_Attributes1 <> MhFldBuff:BUFFER-FIELD("_Attributes1":U):BUFFER-VALUE THEN
          RUN rtb_show_discrepancy ("_Attributes1",
                                    STRING(MhFldBuff:BUFFER-FIELD("_Attributes1":U):BUFFER-VALUE),
                                    STRING(Brtb_field.rtb_Attributes1),
                                    "dbrtb").
        IF Brtb_field.rtb_Charset <> MhFldBuff:BUFFER-FIELD("_Charset":U):BUFFER-VALUE THEN
          RUN rtb_show_discrepancy ("_Charset",
                                    STRING(MhFldBuff:BUFFER-FIELD("_Charset":U):BUFFER-VALUE),
                                    STRING(Brtb_field.rtb_Charset),
                                    "dbrtb").
        IF Brtb_field.rtb_Collation <> MhFldBuff:BUFFER-FIELD("_Collation":U):BUFFER-VALUE THEN
          RUN rtb_show_discrepancy ("_Collation",
                                    STRING(MhFldBuff:BUFFER-FIELD("_Collation":U):BUFFER-VALUE),
                                    STRING(Brtb_field.rtb_Collation),
                                    "dbrtb").
        IF Brtb_flddef.rtb_Fld-misc2[1] <> MhFldBuff:BUFFER-FIELD("_Fld-misc2":U):BUFFER-VALUE(1) THEN
          RUN rtb_show_discrepancy ("_Fld-misc2[1]",
                                    STRING(MhFldBuff:BUFFER-FIELD("_Fld-misc2":U):BUFFER-VALUE(1)),
                                    STRING(Brtb_flddef.rtb_Fld-misc2[1]),
                                    "dbrtb").
      END.

      IF NOT fnIsSameString(Brtb_flddef.rtb_valexp,B_field._valexp) THEN DO:
        ASSIGN MdbValue  = ""
               MrtbValue = "".
        DO Ms = 1 TO LENGTH(B_field._valexp) BY 76:
          MdbValue = MdbValue
                     + (IF MdbValue = "" THEN "" ELSE "~n")
                     + SUBSTRING(B_field._valexp,Ms,76).
        END.

        DO Ms = 1 TO LENGTH(Brtb_flddef.rtb_valexp) BY 76:
          MrtbValue = MrtbValue
                      + (IF MrtbValue = "" THEN "" ELSE "~n")
                      + SUBSTRING(Brtb_flddef.rtb_valexp,Ms,76).
        END.

        RUN rtb_show_discrepancy ("_valexp",
                                  MdbValue,
                                  MrtbValue,
                                  "dbrtb").
      END.

      IF NOT fnIsSameString(Brtb_flddef.rtb_valmsg,B_field._valmsg) THEN
        RUN rtb_show_discrepancy ("_valmsg",
                                  B_field._valmsg,
                                  Brtb_flddef.rtb_valmsg,
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_help,B_field._help) THEN
        RUN rtb_show_discrepancy ("_help",
                                  B_field._help,
                                  Brtb_flddef.rtb_help,
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_desc,B_field._desc) THEN
        RUN rtb_show_discrepancy ("_desc",
                                  B_field._desc,
                                  Brtb_flddef.rtb_desc,
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_col-label,B_field._col-label) THEN
        RUN rtb_show_discrepancy ("_col-label",
                                  B_field._col-label,
                                  Brtb_flddef.rtb_col-label,
                                  "dbrtb").

      IF Brtb_flddef.rtb_fld-case     <> B_field._fld-case THEN
        RUN rtb_show_discrepancy ("_fld-case",
                                  STRING(B_field._fld-case,"Sensitive/Not-Sensitive"),
                                  STRING(Brtb_flddef.rtb_fld-case,"Sensitive/Not-Sensitive"),
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_view-as,B_field._view-as) THEN DO:
        ASSIGN MdbValue  = ""
               MrtbValue = "".
        DO Ms = 1 TO LENGTH(B_field._view-as) BY 76:
          MdbValue = MdbValue
                     + (IF MdbValue = "" THEN "" ELSE "~n")
                     + SUBSTRING(B_field._view-as,Ms,76).
        END.

        DO Ms = 1 TO LENGTH(Brtb_flddef.rtb_view-as) BY 76:
          MrtbValue = MrtbValue
                      + (IF MrtbValue = "" THEN "" ELSE "~n")
                      + SUBSTRING(Brtb_flddef.rtb_view-as,Ms,76).
        END.

        RUN rtb_show_discrepancy ("_view-as",
                                  MdbValue,
                                  MrtbValue,
                                  "dbrtb").
      END.

      IF NOT fnIsSameString(Brtb_flddef.rtb_col-label-sa,B_field._col-label-sa) THEN
        RUN rtb_show_discrepancy ("_col-label-sa",
                                  B_field._col-label-sa,
                                  Brtb_flddef.rtb_col-label-sa,
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_format-sa,B_field._format-sa) THEN
        RUN rtb_show_discrepancy ("_format-sa",
                                  B_field._format-sa,
                                  Brtb_flddef.rtb_format-sa,
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_help-sa,B_field._help-sa) THEN
        RUN rtb_show_discrepancy ("_help-sa",
                                  B_field._help-sa,
                                  Brtb_flddef.rtb_help-sa,
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_initial-sa,B_field._initial-sa) THEN
        RUN rtb_show_discrepancy ("_initial-sa",
                                  B_field._initial-sa,
                                  Brtb_flddef.rtb_initial-sa,
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_label-sa,B_field._label-sa) THEN
        RUN rtb_show_discrepancy ("_label-sa",
                                  B_field._label-sa,
                                  Brtb_flddef.rtb_label-sa,
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_flddef.rtb_valmsg-sa,B_field._valmsg-sa) THEN
        RUN rtb_show_discrepancy ("_valmsg-sa",
                                  B_field._valmsg-sa,
                                  Brtb_flddef.rtb_valmsg-sa,
                                  "dbrtb").

      IF Brtb_flddef.rtb_Width <> B_field._width THEN
        RUN rtb_show_discrepancy ("_width",
                                  B_field._width,
                                  Brtb_flddef.rtb_width,
                                  "dbrtb").
    END.

    /*
     Process field triggers
    */
    RUN check_field_triggers (BUFFER B_File,
                              BUFFER Brtb_dbfile,
                              BUFFER B_field,
                              BUFFER Brtb_field).

  END. /* rtb-field-loop */

  FOR EACH B_field OF B_file NO-LOCK:
    FIND Brtb_field OF Brtb_file
       WHERE Brtb_field.local-field-name = B_field._field-name
       NO-LOCK NO-ERROR.
    IF NOT AVAILABLE Brtb_field THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("Field",
                                B_field._field-name,
                                "",
                                "db-only":U).
    END.
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-check_field_triggers) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE check_field_triggers Procedure 
PROCEDURE check_field_triggers PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Compare logical with physical field level triggers
  Parameters:  BUFFER B_file       - _File buffer
               BUFFER Brtb_dbfile  - rtb_dbfile buffer
               BUFFER B_field      - _Field buffer
               BUFFER Brtb_field   - rtb_field buffer
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE PARAMETER BUFFER B_File      FOR DICTDB._File.
  DEFINE PARAMETER BUFFER Brtb_dbfile FOR rtb.rtb_dbfile.
  DEFINE PARAMETER BUFFER B_field     FOR DICTDB._Field.
  DEFINE PARAMETER BUFFER Brtb_field  FOR rtb.rtb_field.

  DEFINE BUFFER B_field-trig FOR DICTDB._Field-trig.
  DEFINE BUFFER Brtb_fldtrig FOR rtb.rtb_fldtrig.

  rtb-field-trig-loop:
  FOR EACH Brtb_fldtrig OF Brtb_field NO-LOCK:
    FIND B_field-trig OF B_field
      WHERE B_field-trig._event = Brtb_fldtrig.rtb_event NO-LOCK NO-ERROR.
    IF NOT AVAILABLE B_field-trig THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("Field Trigger",
                                "",
                                (Brtb_field.local-field-name
                                 + " / " + Brtb_fldtrig.rtb_event),
                                "rtb-only":U).
      NEXT rtb-field-trig-loop.
    END.

    IF B_field-trig._override <> Brtb_fldtrig.rtb_override
       OR NOT fnIsSameString(B_field-trig._proc-name,Brtb_fldtrig.rtb_proc-name) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      PUT STREAM Sout UNFORMATTED
        "**Difference(s) in Field Trigger: " B_field-trig._event FORMAT "x(78)" SKIP.
    END.

    IF B_field-trig._override <> Brtb_fldtrig.rtb_override THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy (("Field Trigger " + B_field-trig._event
                                  + "_override"),
                                B_field-trig._override,
                                Brtb_fldtrig.rtb_override,
                                "dbrtb").
    END.

    IF NOT fnIsSameString(B_field-trig._proc-name,Brtb_fldtrig.rtb_proc-name) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy (("Field Trigger " + B_field-trig._event
                                  + "_proc-name"),
                                B_field-trig._proc-name,
                                Brtb_fldtrig.rtb_proc-name,
                                "dbrtb").
    END.

  END. /* field-trig-loop */

  FOR EACH B_field-trig OF B_field NO-LOCK:
    FIND Brtb_fldtrig OF Brtb_field
      WHERE Brtb_fldtrig.rtb_event = B_field-trig._event NO-LOCK NO-ERROR.

    IF NOT AVAILABLE Brtb_fldtrig THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy (("Field Trigger " + B_file._file-name
                                 + "." + B_field._field-name),
                                B_field-trig._event,
                                "",
                                "db-only":U).
    END.
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-check_files) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE check_files Procedure 
PROCEDURE check_files PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Compare logical wiht physical tables
  Parameters:  BUFFER B_file       - _File buffer
               BUFFER Brtb_file    - rtb_file buffer
               BUFFER Brtb_dbfile  - rtb_dbfile buffer
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE VARIABLE Merror           AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mfile-pmod       AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mfile-upd-status AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mvalues          AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mfile-version    AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Ms               AS INTEGER     NO-UNDO.

  DEFINE BUFFER B_file      FOR DICTDB._File.
  DEFINE BUFFER Brtb_dbfile FOR rtb.rtb_dbfile.
  DEFINE BUFFER Brtb_file   FOR rtb.rtb_file.

  rtb-file-loop:
  FOR EACH Brtb_dbfile OF Brtb_dbase NO-LOCK:
    MprintName = YES.
    IF NOT PdiffOnly THEN
      PUT STREAM Sout UNFORMATTED "Checking Table: " 
        Brtb_dbfile.local-file-name  FORMAT "x(78)" SKIP.

    FIND B_file of B_db
      WHERE B_file._file-name = Brtb_dbfile.local-file-name
        AND B_file._DB-lang   = 0                            /* no sql schema */
        NO-LOCK NO-ERROR.

    IF NOT AVAILABLE B_file THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("Table",
                                "",
                                Brtb_dbfile.local-file-name,
                                "rtb-only":U).
      NEXT rtb-file-loop.
    END.


    /*
     Get version and pmod of file
    */
    Mvalues = DYNAMIC-FUNCTION('fnRtbGetSchemaPmodVer':U,
                               Brtb_object.wspace-id,
                               -2,
                               Brtb_dbfile.file-obj-type,
                               Brtb_dbfile.file-object).
    IF ENTRY(1,Mvalues,CHR(1)) = "ERROR":U THEN DO:
      Merror = ENTRY(1,Mvalues,CHR(1)).
    END.
    ELSE
      ASSIGN Mfile-pmod       = ENTRY(1,Mvalues,CHR(1))
             Mfile-version    = INTEGER(ENTRY(2,Mvalues,CHR(1)))
             Mfile-upd-status = ENTRY(3,Mvalues,CHR(1)).

    FIND Brtb_file
      WHERE Brtb_file.obj-type = Brtb_dbfile.file-obj-type
        AND Brtb_file.object   = Brtb_dbfile.file-object
        AND Brtb_file.pmod     = Mfile-pmod
        AND Brtb_file.version  = Mfile-version NO-LOCK.

    /*
     Compare File Header
    */
    IF NOT fnIsSameString(Brtb_dbfile.local-file-name,B_file._file-name) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_file-name",
                                B_file._file-name,
                                Brtb_dbfile.local-file-name,
                                "dbrtb").
    END.

    IF Brtb_file.rtb_hidden   <> B_file._hidden THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_hidden",
                                B_file._hidden,
                                Brtb_file.rtb_hidden,
                                "dbrtb").
    END.

    IF Brtb_file.rtb_frozen   <> B_file._frozen THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_frozen",
                                B_file._frozen,
                                Brtb_file.rtb_frozen,
                                "dbrtb").
    END.

    IF NOT fnIsSameString(Brtb_file.rtb_dump-name,B_file._dump-name) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_dump-name",
                                B_file._dump-name,
                                Brtb_file.rtb_dump-name,
                                "dbrtb").
    END.

    IF NOT fnIsSameString(Brtb_file.rtb_fil-misc2[6],B_file._fil-misc2[6]) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_fil-misc2[6] (Replication)",
                                B_file._fil-misc2[6],
                                Brtb_file.rtb_fil-misc2[6],
                                "dbrtb").
    END.

    IF NOT fnIsSameString(Brtb_file.rtb_valexp,B_file._valexp) THEN DO:
      ASSIGN MdbValue  = ""
             MrtbValue = "".
      DO Ms = 1 TO LENGTH(B_file._valexp) BY 76:
        MdbValue = MdbValue
                   + (IF MdbValue = "" THEN "" ELSE "~n")
                   + SUBSTRING(B_file._valexp,Ms,76).
      END.
      DO Ms = 1 TO LENGTH(Brtb_file.rtb_valexp) BY 76:
        MrtbValue = MrtbValue
                   + (IF MrtbValue = "" THEN "" ELSE "~n")
                   + SUBSTRING(Brtb_file.rtb_valexp,Ms,76).
      END.
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_valexp",
                                MdbValue,
                                MrtbValue,
                                "dbrtb").
    END.

    IF Brtb_dbfile.area-name <> getStorageAreaName({&TABLE-OBJECT}, B_File._File-num) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("Storage Area",
                                getStorageAreaName({&TABLE-OBJECT}, B_File._File-num),
                                Brtb_dbfile.area-name,
                                "dbrtb").
    END.
    
    IF NOT fnIsSameString(Brtb_file.rtb_valmsg,B_file._valmsg) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_valmsg",
                                B_file._valmsg,
                                Brtb_file.rtb_valmsg,
                                "dbrtb").
    END.

    IF NOT fnIsSameString(Brtb_file.rtb_desc,B_file._desc) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_desc",
                                B_file._desc,
                                Brtb_file.rtb_desc,
                                "dbrtb").
    END.

    IF NOT fnIsSameString(Brtb_file.rtb_file-label,B_file._file-label) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_file-label",
                                B_file._file-label,
                                Brtb_file.rtb_file-label,
                                "dbrtb").
    END.

    IF NOT fnIsSameString(Brtb_file.rtb_file-label-sa,B_file._file-label-sa) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_file-label-sa",
                                B_file._file-label-sa,
                                Brtb_file.rtb_file-label-sa,
                                "dbrtb").
    END.

    IF NOT fnIsSameString(Brtb_file.rtb_valmsg-sa,B_file._valmsg-sa) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_valmsg-sa",
                                B_file._valmsg-sa,
                                Brtb_file.rtb_valmsg-sa,
                                "dbrtb").
    END.

    RUN check_file_triggers (BUFFER B_file,
                             BUFFER Brtb_file,
                             BUFFER Brtb_dbfile).

    RUN check_fields (BUFFER B_File,
                      BUFFER Brtb_file,
                      BUFFER Brtb_dbfile).

    RUN check_indices (BUFFER B_file,
                       BUFFER Brtb_file,
                       BUFFER Brtb_dbfile).

  END. /* rtb-file-loop */

  /*
   Check that all files in Progress Dictionary exist in RTB 
   Note that we do not have to check fields etc because if the
   file exists this has already been done above!
  */
  db-file-loop:
  FOR EACH B_file OF B_db
    WHERE
      B_file._DB-lang = 0 AND                          /* no sql schema */
      NOT B_file._file-name BEGINS "_"  AND            /* no meta schema */
      B_file._tbl-type = "T" AND                       /* only user "tables" */
      ((B_file._For-type  = ?) OR                      /* native Progress or */
       (B_file._For-type <> ? AND NOT B_file._hidden)) /* dataserver schema */
     NO-LOCK:

    FIND FIRST Brtb_dbfile OF Brtb_dbase
      WHERE Brtb_dbfile.local-file-name = B_file._file-name NO-LOCK NO-ERROR.

    IF NOT AVAILABLE Brtb_dbfile THEN DO:
      RUN rtb_show_discrepancy ("Table",
                                B_file._file-name,
                                "",
                                "db-only":U).
      NEXT db-file-loop.
    END.
  END. /* db-file-loop */

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-check_file_triggers) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE check_file_triggers Procedure 
PROCEDURE check_file_triggers PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Compare logical with physical file triggers
  Parameters:  BUFFER B_file       - _File buffer
               BUFFER Brtb_file    - rtb_file buffer
               BUFFER Brtb_dbfile  - rtb_dbfile buffer
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE PARAMETER BUFFER B_file      FOR DICTDB._File.
  DEFINE PARAMETER BUFFER Brtb_file   FOR rtb.rtb_file.
  DEFINE PARAMETER BUFFER Brtb_dbfile FOR rtb.rtb_dbfile.

  DEFINE BUFFER B_file-trig  FOR DICTDB._File-trig.
  DEFINE BUFFER Brtb_filtrig FOR rtb.rtb_filtrig.

  rtb-filetrig-loop:
  FOR EACH Brtb_filtrig OF Brtb_file NO-LOCK:
    FIND B_file-trig OF B_file
       WHERE B_file-trig._event = Brtb_filtrig.rtb_event NO-LOCK NO-ERROR.
    IF NOT AVAILABLE B_file-trig THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("Table Trigger",
                                "", 
                                "Brtb_filtrig.rtb_event",
                                "rtb-only":U).
       NEXT rtb-filetrig-loop.
    END.

    IF B_file-trig._override <> Brtb_filtrig.rtb_override
       OR NOT fnIsSameString(B_file-trig._proc-name,Brtb_filtrig.rtb_proc-name) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      PUT STREAM Sout UNFORMATTED
        "**Difference(s) in Table Trigger: " B_file-trig._event " :" SKIP.
    END.

    IF B_file-trig._override <> Brtb_filtrig.rtb_override THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_override",
                                B_file-trig._override,
                                Brtb_filtrig.rtb_override,
                                "dbrtb").
    END.

    IF NOT fnIsSameString(B_file-trig._proc-name,Brtb_filtrig.rtb_proc-name) THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("_proc-name",
                                B_file-trig._proc-name,
                                Brtb_filtrig.rtb_proc-name,
                                "dbrtb").
    END.

  END. /* of filetrig-loop */

  FOR EACH B_file-trig OF B_file NO-LOCK:
    FIND Brtb_filtrig OF Brtb_file
       WHERE Brtb_filtrig.rtb_event = B_file-trig._event NO-LOCK NO-ERROR.

    IF NOT AVAILABLE Brtb_filtrig THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("Table Trigger",
                                "B_file-trig._event", 
                                "",
                                "db-only":U).
    END.
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-check_indices) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE check_indices Procedure 
PROCEDURE check_indices PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Compare logical with physical indices
  Parameters:  BUFFER B_file       - _File buffer
               BUFFER Brtb_file    - rtb_file buffer
               BUFFER Brtb_dbfile  - rtb_dbfile buffer
  Notes:       Note the special handling of word indices...
               Progress indicates that an index is not a word index by setting
               the _wordidx field to be 0 or ?.  We must check for either value.
------------------------------------------------------------------------------*/
  DEFINE PARAMETER BUFFER B_file      FOR DICTDB._File.
  DEFINE PARAMETER BUFFER Brtb_file   FOR rtb.rtb_file.
  DEFINE PARAMETER BUFFER Brtb_dbfile FOR rtb.rtb_dbfile.

  DEFINE BUFFER B_field       FOR DICTDB._Field.
  DEFINE BUFFER B_index       FOR DICTDB._Index.
  DEFINE BUFFER B_index-field FOR DICTDB._Index-Field.
  DEFINE BUFFER Brtb_field    FOR rtb.rtb_field.
  DEFINE BUFFER Brtb_idxfld   FOR rtb.rtb_idxfld.
  DEFINE BUFFER Brtb_index    FOR rtb.rtb_index.

  rtb-index-loop:
  FOR EACH Brtb_index OF Brtb_file NO-LOCK:
    FIND B_index OF B_file 
       WHERE B_index._index-name = Brtb_index.rtb_index-name NO-LOCK NO-ERROR.

    IF NOT AVAILABLE B_index THEN DO:
      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
      RUN rtb_show_discrepancy ("Index",
                                "",
                                Brtb_index.rtb_index-name,
                                "rtb-only":U).
       NEXT rtb-index-loop.
    END.

    IF Brtb_index.rtb_unique            <> B_index._unique 
       OR Brtb_index.rtb_active         <> B_index._active 
       OR (Brtb_file.rtb_prime-index-id =  Brtb_index.index-id
           AND B_file._prime-index      <> RECID(B_index)) 
       OR NOT fnIsSameString(Brtb_index.rtb_desc,B_index._desc)
       OR NOT fnIsSameString(Brtb_index.rtb_index-name,B_index._index-name)
       OR (Brtb_index.rtb_wordidx = 1 AND B_index._wordidx <> 1)
       OR (Brtb_index.rtb_wordidx <> 1 AND B_index._wordidx = 1)
       OR (Brtb_index.area-name <> getStorageAreaName({&INDEX-OBJECT}, B_index._idx-num)) THEN DO:

      RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).

      PUT STREAM Sout UNFORMATTED
        "**Difference(s) in Index " Brtb_index.rtb_index-name " :" SKIP.

      IF NOT fnIsSameString(Brtb_index.rtb_index-name,B_index._index-name) THEN
        RUN rtb_show_discrepancy ("_index-name",
                                  B_index._index-name,
                                  Brtb_index.rtb_index-name,
                                  "dbrtb").

      IF Brtb_index.rtb_unique <> B_index._unique THEN
        RUN rtb_show_discrepancy ("_unique",
                                  STRING(B_index._unique,"Unique/Not-Unique"),
                                  STRING(Brtb_index.rtb_unique,"Unique/Not-Unique"),
                                  "dbrtb").

      IF Brtb_index.rtb_active <> B_index._active THEN
        RUN rtb_show_discrepancy ("_active",
                                  STRING(B_index._active,"Active/In-active"),
                                  STRING(Brtb_index.rtb_active,"Active/In-active"),
                                  "dbrtb").

      IF NOT fnIsSameString(Brtb_index.rtb_desc,B_index._desc) THEN
        RUN rtb_show_discrepancy ("_desc",
                                  B_index._desc,
                                  Brtb_index.rtb_desc,
                                  "dbrtb").

      IF (Brtb_index.rtb_wordidx = 1 AND B_index._wordidx <> 1)
          OR (Brtb_index.rtb_wordidx <> 1 AND B_index._wordidx = 1) THEN
        RUN rtb_show_discrepancy ("_wordidx",
                                  STRING(B_index._wordidx),
                                  STRING(Brtb_index.rtb_wordidx),
                                  "dbrtb").

      IF Brtb_index.area-name <> getStorageAreaName({&INDEX-OBJECT}, B_index._idx-num) THEN
        RUN rtb_show_discrepancy ("Storage Area",
                                  getStorageAreaName({&INDEX-OBJECT}, B_index._idx-num),
                                  Brtb_index.area-name,
                                  "dbrtb").

      IF Brtb_file.rtb_prime-index-id = Brtb_index.index-id
         AND B_file._prime-index <> RECID(B_index) THEN DO:
        FIND B_index WHERE RECID(B_index) = B_file._prime-index NO-LOCK NO-ERROR.
        RUN rtb_show_discrepancy ("Primary Index",
                                  (IF AVAILABLE B_index THEN
                                    B_index._index-name
                                   ELSE
                                     "?"),
                                  Brtb_index.rtb_index-name,
                                  "dbrtb").
      END.

    END.

    /*
     Check each index field assignment
    */
    index-field-loop:
    FOR EACH Brtb_idxfld OF Brtb_index NO-LOCK,
       Brtb_field OF Brtb_file
       WHERE Brtb_field.field-id = Brtb_idxfld.field-id NO-LOCK:

      FIND B_index-field OF B_index
        WHERE B_index-field._index-seq = Brtb_idxfld.rtb_index-seq 
        NO-LOCK NO-ERROR.

      IF NOT AVAILABLE B_index-field THEN DO:
        RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
        RUN rtb_show_discrepancy ("Index Field",
                                  "",
                                  (Brtb_index.rtb_index-name
                                   + " / "
                                   + Brtb_field.local-field-name),
                                  "rtb-only":U).
        LEAVE index-field-loop.
      END.

      FIND B_field 
        WHERE RECID(B_field) = B_index-field._field-recid NO-LOCK.

      IF B_field._field-name <> Brtb_field.local-field-name THEN DO:
        RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
        RUN rtb_show_discrepancy (("Index Field Names mismatch in " 
                                   + B_index._index-name),
                                  B_field._field-name,
                                  Brtb_field.local-field-name,
                                  "dbrtb").
        LEAVE index-field-loop.
      END.

      IF B_index-field._ascending  <> Brtb_idxfld.rtb_ascending THEN DO:
        RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
        RUN rtb_show_discrepancy (("Index Field _ascending in " 
                                   + B_index._index-name + " / "
                                   + Brtb_field.local-field-name),
                                  STRING(B_index-field._ascending,"Ascending/Descending"),
                                  STRING(Brtb_idxfld.rtb_ascending,"Ascending/Descending"),
                                  "dbrtb").
      END.

      IF B_index-field._abbreviate <> Brtb_idxfld.rtb_abbreviate THEN DO:
        RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
        RUN rtb_show_discrepancy (("Index Field _abbreviate in " 
                                   + B_index._index-name + " / "
                                   + Brtb_field.local-field-name),
                                  STRING(B_index-field._abbreviate,"Abbreviated/Not-Abbreviated"),
                                  STRING(Brtb_idxfld.rtb_abbreviate,"Abbreviated/Not-Abbreviated"),
                                  "dbrtb").
      END.

    END. /* of EACH Brtb_idxfld */

  END. /* of EACH Brtb_index */

    
  IF NOT B_file._dft-pk THEN DO: /* If not default index */

    /*
     Check for missing primary index in logical schema.
    */
    IF Brtb_file.rtb_prime-index-id = 0 THEN DO:
      
      FIND B_index WHERE RECID(B_index) = B_file._prime-index NO-LOCK NO-ERROR.
      
      IF AVAILABLE B_index THEN DO:
        RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
        RUN rtb_show_discrepancy ("Primary Index",
                                  B_index._index-name,
                                  "?",
                                  "dbrtb").
      END.
    END.
    
    db-index-loop:
    FOR EACH B_index OF B_file NO-LOCK:
      FIND FIRST Brtb_index OF Brtb_file
         WHERE Brtb_index.rtb_index-name = B_index._index-name
         NO-LOCK NO-ERROR.

      IF NOT AVAILABLE Brtb_index THEN DO:
        RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
        RUN rtb_show_discrepancy ("Index",
                                  B_index._index-name,
                                  "",
                                  "db-only":U).
        NEXT db-index-loop.
      END.

      FOR EACH B_index-field OF B_index NO-LOCK:
        FIND FIRST Brtb_idxfld OF Brtb_index
          WHERE Brtb_idxfld.rtb_index-seq = B_index-field._index-seq
          NO-LOCK NO-ERROR.

        IF NOT AVAILABLE Brtb_idxfld THEN DO:
          FIND FIRST B_field
            WHERE RECID(B_field) = B_index-field._field-recid NO-LOCK.
          RUN print_entity_name ("Table",Brtb_dbfile.local-file-name).
          RUN rtb_show_discrepancy ("Index Field",
                                    (B_index._index-name + " / "
                                     + B_field._field-name),
                                     "",
                                     "db-only":U).
        END.
      END.  /* for each b_index-field of b_index */
    END.  /* for each b_index of b_file */

  END. /* not b_file._dft-ok */

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-check_sequences) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE check_sequences Procedure 
PROCEDURE check_sequences PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Compare logical with physical sequences.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE BUFFER B_sequence    FOR DICTDB._Sequence.
  DEFINE BUFFER Brtb_sequence FOR rtb.rtb_sequence.


  rtb-sequence-loop:
  FOR EACH Brtb_sequence OF Brtb_dbase NO-LOCK:
    MprintName = YES.
    IF NOT PdiffOnly THEN
      PUT STREAM Sout UNFORMATTED
        "Checking Sequence: " Brtb_sequence.rtb_seq-name FORMAT "x(78)" SKIP.

    FIND B_sequence OF B_db
      WHERE B_sequence._seq-name = Brtb_sequence.rtb_seq-name NO-LOCK NO-ERROR.

    IF NOT AVAILABLE B_sequence THEN DO:
      RUN print_entity_name ("Sequence",Brtb_sequence.rtb_seq-name).      
      RUN rtb_show_discrepancy ("Sequence",
                                "",
                                Brtb_sequence.rtb_seq-name,
                                "rtb-only":U).
      NEXT rtb-sequence-loop.
    END.

    IF NOT fnIsSameString(Brtb_sequence.rtb_seq-name,B_sequence._seq-name) THEN DO:
      RUN print_entity_name ("Sequence",Brtb_sequence.rtb_seq-name).
      RUN rtb_show_discrepancy ("_seq-name",
                                B_sequence._seq-name,
                                Brtb_sequence.rtb_seq-name,
                                "dbrtb").
    END.

    IF Brtb_sequence.rtb_cycle-ok <> B_sequence._cycle-ok THEN DO:
      RUN print_entity_name ("Sequence",Brtb_sequence.rtb_seq-name).
      RUN rtb_show_discrepancy ("_cycle-ok",
                                STRING(B_sequence._cycle-ok),
                                STRING(Brtb_sequence.rtb_cycle-ok),
                                "dbrtb").
    END.

    IF Brtb_sequence.rtb_seq-incr <> B_sequence._seq-incr THEN DO:
      RUN print_entity_name ("Sequence",Brtb_sequence.rtb_seq-name).
      RUN rtb_show_discrepancy ("_seq-incr",
                                STRING(B_sequence._seq-incr),
                                STRING(Brtb_sequence.rtb_seq-incr),
                                "dbrtb").
    END.

    IF Brtb_sequence.rtb_seq-init <> B_sequence._seq-init THEN DO:
      RUN print_entity_name ("Sequence",Brtb_sequence.rtb_seq-name).
      RUN rtb_show_discrepancy ("_seq-init",
                                STRING(B_sequence._seq-init),
                                STRING(Brtb_sequence.rtb_seq-init),
                                "dbrtb").
    END.

    IF Brtb_sequence.rtb_seq-max <> B_sequence._seq-max THEN DO:
      RUN print_entity_name ("Sequence",Brtb_sequence.rtb_seq-name).
      RUN rtb_show_discrepancy ("_seq-max",
                                STRING(B_sequence._seq-max),
                                STRING(Brtb_sequence.rtb_seq-max),
                                "dbrtb").
    END.

    IF Brtb_sequence.rtb_seq-min <> B_sequence._seq-min THEN DO:
      RUN print_entity_name ("Sequence",Brtb_sequence.rtb_seq-name).
      RUN rtb_show_discrepancy ("_seq-min",
                                STRING(B_sequence._seq-min),
                                STRING(Brtb_sequence.rtb_seq-min),
                                "dbrtb").
    END.

  END.  /* rtb-sequence-loop */

  db-sequence-loop:
  FOR EACH B_sequence OF B_db NO-LOCK:
    FIND Brtb_sequence OF Brtb_dbase
      WHERE Brtb_sequence.rtb_seq-name = B_sequence._seq-name NO-LOCK NO-ERROR.

    IF NOT AVAILABLE Brtb_sequence THEN DO:
      RUN rtb_show_discrepancy ("Sequence",
                                B_sequence._seq-name,
                                "",
                                "db-only":U).
      NEXT db-sequence-loop.
    END.
  END.  /* db-sequence-loop*/

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-do_report) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE do_report Procedure 
PROCEDURE do_report PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Main report block.
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  MerrCount = 0.

  rpt-block:
  DO:
    FIND Brtb_object WHERE ROWID(Brtb_object) = PobjRowid NO-LOCK NO-ERROR.
    IF NOT AVAILABLE Brtb_object THEN DO:
      Merror = "Object record for specified ROWID not available.".
      LEAVE rpt-block.
    END.

    FIND Brtb_dbase 
       WHERE Brtb_dbase.pmod     = Brtb_object.committed-pmod
         AND Brtb_dbase.obj-type = Brtb_object.obj-type
         AND Brtb_dbase.object   = Brtb_object.object
         AND Brtb_dbase.version  = Brtb_object.committed-version NO-LOCK.

    /*
      Get appropriate _Db record
    */
    FIND B_db WHERE B_db._Db-name = Brtb_dbase.object
      NO-LOCK NO-ERROR.
    IF NOT AVAILABLE B_db THEN
      FIND B_db WHERE B_db._Db-name = ? NO-LOCK NO-ERROR.
    IF NOT AVAILABLE B_db THEN
      FIND FIRST B_db NO-LOCK.

    {rtb/i/rtb_rpthdr.i 
        &title="""Database Integrity Check Report"""
        &crtieria="""Workspace : "" Brtb_object.wspace-id SKIP
                   ""Database  : "" Brtb_dbase.object FORMAT ""x(32)""
                     SKIP(1)"
        &center-criteria=NO
        &STREAM=Sout}

    RUN check_sequences.
    RUN check_files.

  END.

  PUT STREAM Sout UNFORMATTED
    SKIP
    SUBSTITUTE("&1 differences found.",
               IF MerrCount = 0 THEN "No" ELSE STRING(MerrCount))
    SKIP.

  {rtb/i/rtb_rptftr.i &STREAM=Sout}

  RETURN Merror.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-print_entity_name) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE print_entity_name Procedure 
PROCEDURE print_entity_name PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Print label for specified entity name as required
  Parameters:  INPUT
                  Plabel - Label for entity
                  Pvalue - Name of entity
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Plabel AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER Pvalue AS CHARACTER   NO-UNDO.

  /*
   If printing differences only and the entity name should be printed...
  */
  IF PdiffOnly AND MprintName THEN DO:
    PUT STREAM Sout UNFORMATTED SKIP(1)
       Plabel ": " Pvalue  FORMAT "x(78)" SKIP.
    MprintName = NO.  /* no need to print name now */
  END.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_show_discrepancy) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_show_discrepancy Procedure 
PROCEDURE rtb_show_discrepancy PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER PLabel    AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER PdbValue  AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER PrtbValue AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER Pstatus   AS CHARACTER   NO-UNDO.

  DEFINE VARIABLE Mline AS CHARACTER FORMAT "x(78)"  NO-UNDO.

  FORM
    "**Difference in " Plabel              FORMAT "x(60)" SKIP
    SPACE(2) "Workspace DB:"                              SKIP
    space(4) PdbValue                      FORMAT "x(75)" SKIP
    SPACE(2) "Roundtable Schema:"                         SKIP
    space(4) PrtbValue                     FORMAT "x(75)" SKIP(1)
    WITH FRAME f-values
    NO-BOX NO-LABELS STREAM-IO.

  FORM
    "**Difference **" SKIP
    SPACE(2) Mline    SKIP(1)
    WITH FRAME f-oneonly
    NO-BOX NO-LABELS STREAM-IO.

  CASE Pstatus:
    WHEN "db-only":U THEN DO:
      Mline = SUBSTITUTE("&1 &2 is not in Roundtable Schema",Plabel,PdbValue).
      DISPLAY STREAM Sout
        Mline WITH FRAME f-oneonly.
    END.
    WHEN "rtb-only":U THEN DO:
      Mline = SUBSTITUTE("&1 &2 is not in Workspace DB",Plabel,PrtbValue).
      DISPLAY STREAM Sout
        Mline WITH FRAME f-oneonly.
    END.
    OTHERWISE
      DISPLAY STREAM Sout
        Plabel
        PdbValue
        PrtbValue
        WITH FRAME f-values.
  END CASE.

  MerrCount = MerrCount + 1.

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

/* ************************  Function Implementations ***************** */

&IF DEFINED(EXCLUDE-fnIsSameString) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION fnIsSameString Procedure 
FUNCTION fnIsSameString RETURNS LOGICAL PRIVATE
        ( INPUT pcValue1 AS CHARACTER,
          INPUT pcValue2 AS CHARACTER ):
/*------------------------------------------------------------------------------
  Purpose:  Returns TRUE if specified values are equivalent.
        Notes:  Using this instead of fnRtbCompareStrings in rtb_funclib.p
                to effect empty string and unkown value equivalence.
------------------------------------------------------------------------------*/
  DEFINE VARIABLE lIsSame AS LOGICAL    NO-UNDO.

  /*
   Consider unknown and empty string the same
  */
  IF (pcValue1 EQ "":U AND pcValue2 = ?)
     OR (pcValue1 EQ ? AND pcValue2 = "":U) THEN
    lIsSame = TRUE.
  ELSE
    lIsSame = COMPARE(pcValue1,"EQ":U,pcValue2,"CASE-SENSITIVE":U).

  RETURN lIsSame.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF
